Index: ram/idfield.c
===================================================================
--- ram/idfield.c	(revision df097bf59e892ec2e9bbb4a5696044afa1d5bf16)
+++ ram/idfield.c	(revision 342a56fb7d496f8e81315e423dc9309308a74300)
@@ -18,24 +18,74 @@
 #include "instdsp.h"
 
-extern	short	select(), stdmkey(), stddkey(), nokey(), cxkstd(), cykstd();
-extern	short	vtoy(), ttox(), timeto(), vcputsv(), dswin(), stdctp1();
-extern	short	whatbox(), inspnt(), pntsel(), setseg(), showpt();
-
-extern	short	et_null(), ef_null(), rd_null(), nd_null();
-extern	short	et_ipnt(), ef_ipnt(), rd_ipnt(), nd_ipnt();
-extern	short	et_idin(), ef_idin(), rd_idin(), nd_idin();
-extern	short	et_ivce(), ef_ivce(), rd_ivce(), nd_ivce();
-extern	short	et_icnf(), ef_icnf(), rd_icnf(), nd_icnf();
-extern	short	et_ival(), ef_ival(), rd_ival(), nd_ival();
-extern	short	et_itim(), ef_itim(), rd_itim(), nd_itim();
-extern	short	et_iosc(), ef_iosc(), rd_iosc(), nd_iosc();
-extern	short	et_iact(), ef_iact(), rd_iact(), nd_iact();
-extern	short	et_iwsn(), ef_iwsn(), rd_iwsn(), nd_iwsn();
-extern	short	et_ires(), ef_ires(), rd_ires(), nd_ires();
-extern	short	et_imlt(), ef_imlt(), rd_imlt(), nd_imlt();
-
-extern	unsigned	fromfpu();
-
-extern	char	*memset();
+extern	void	select(void);
+extern	void	stdmkey(void);
+extern	void	stddkey(void);
+extern	short	nokey(void);
+extern	void	cxkstd(void);
+extern	void	cykstd(void);
+extern	short	vtoy(short val, short window);
+extern	short	ttox(unsigned time, short window);
+extern	short	timeto(short fn, short pj);
+extern	void	vcputsv(int *obase, int nw, int fg, int bg, int row, int col, char *str, int pitch);
+extern	void	dswin(short n);
+extern	short	stdctp1(void);
+extern	short	whatbox(void);
+extern	short	inspnt(struct instdef *ip, short fn, short inpnt);
+extern	void	pntsel(void);
+extern	void	setseg(short pn, unsigned ptime);
+extern	void	showpt(short q);
+
+extern	short	et_null(void);
+extern	short	ef_null(void);
+extern	short	rd_null(void);
+extern	short	nd_null(void);
+extern	short	et_ipnt(short n);
+extern	short	ef_ipnt(short n);
+extern	short	rd_ipnt(short n);
+extern	short	nd_ipnt(short n, short k);
+extern	short	et_idin(short n);
+extern	short	ef_idin(short n);
+extern	short	rd_idin(short n);
+extern	short	nd_idin(short n, short k);
+extern	short	et_ivce(short n);
+extern	short	ef_ivce(short n);
+extern	short	rd_ivce(short n);
+extern	short	nd_ivce(short n, short k);
+extern	short	et_icnf(short n);
+extern	short	ef_icnf(short n);
+extern	short	rd_icnf(short n);
+extern	short	nd_icnf(short n, short k);
+extern	short	et_ival(short n);
+extern	short	ef_ival(short n);
+extern	short	rd_ival(short n);
+extern	short	nd_ival(short n, short k);
+extern	short	et_itim(short n);
+extern	short	ef_itim(short n);
+extern	short	rd_itim(short n);
+extern	short	nd_itim(short n, short k);
+extern	short	et_iosc(short nn);
+extern	short	ef_iosc(short nn);
+extern	short	rd_iosc(short nn);
+extern	short	nd_iosc(short nn, short k);
+extern	short	et_iact(short nn);
+extern	short	ef_iact(short nn);
+extern	void	rd_iact(short nn);
+extern	short	nd_iact(short nn, short k);
+extern	short	et_iwsn(short nn);
+extern	short	ef_iwsn(short nn);
+extern	short	rd_iwsn(short nn);
+extern	short	nd_iwsn(short nn, short k);
+extern	short	et_ires(short n);
+extern	short	ef_ires(short n);
+extern	short	rd_ires(short n);
+extern	short	nd_ires(short n, short k);
+extern	short	et_imlt(short n);
+extern	short	ef_imlt(short n);
+extern	short	rd_imlt(short n);
+extern	short	nd_imlt(short n, short k);
+
+extern	unsigned	fromfpu(unsigned fputime);
+
+extern	char	*memset(char *sp, char c, int n);
 
 /* 
@@ -73,5 +123,10 @@
 extern	struct	instdef	vbufs[];
 
-short	idx_key(), idnfld(), idcxupd(), idcyupd(), ikyup(), ikydn();
+void	idx_key(void);
+short	idnfld(short k);
+void	idcxupd(void);
+void	idcyupd(void);
+void	ikyup(void);
+void	ikydn(void);
 
 /* 
@@ -165,6 +220,5 @@
 */
 
-short
-ikydn()
+void ikydn(void)
 {
 	imflag = FALSE;
@@ -177,6 +231,5 @@
 */
 
-short
-ikyup()
+void ikyup(void)
 {
 	if (imflag)
@@ -193,6 +246,5 @@
 */
 
-short
-idcyupd()
+void idcyupd(void)
 {
 	register short pval, vh, vl;
@@ -263,6 +315,5 @@
 */
 
-short
-idcxupd()
+void idcxupd(void)
 {
 	register unsigned th, tl;
@@ -384,7 +435,5 @@
 */
 
-short
-idnfld(k)
-short k;
+short idnfld(short k)
 {
 	register short endpnt, basepnt, t, fn;
@@ -486,6 +535,5 @@
 */
 
-short
-idx_key()
+void idx_key(void)
 {
 	register struct sment *smp;
@@ -566,5 +614,5 @@
 */
 
-idfield()
+void idfield(void)
 {
 	idimsw  = FALSE;