Index: readme.txt
===================================================================
--- readme.txt	(revision 49efb91c2113e3a4d2a35361ede72619a0f02e1e)
+++ readme.txt	(revision 0529a190d977cfa707dc41585048845e7dde8470)
@@ -91,4 +91,16 @@
   ../configure --prefix=/opt/sdl2 --with-sdl-prefix=/opt/sdl2
 
+  make
+  make install
+  
+  # Build and install rtmidi
+  
+  tar zxvf rtmidi-3.0.0.tar.gz
+  cd rtmidi-3.0.0
+  mkdir build
+  cd build
+  
+  ../configure --prefix=/opt/rtmidi
+  
   make
   make install
@@ -276,5 +288,5 @@
 -----------------
 
-Here's what we currently emulate:
+Here's what we emulate:
 
   * Motorola 68000 CPU. This is actually the Musashi CPU emulator by
@@ -283,17 +295,25 @@
       https://github.com/kstenerud/Musashi
 
+  * Motorola MC6840: Timers.
+
+  * Rockwell R65C52: Serial console and MIDI ports.
+
+  * Epson SED1335: LCD controller.
+
   * Intel 82716: Video chip.
 
-  * Epson SED1335: LCD controller.
+  * National Semiconductor LMC835: Equalizer.
+
+  * General Instrument AY-3-8910: A sound chip, which is not used for
+    sound generation, but only for its I/O ports. It connects the CPU
+    to the above equalizer chip.
 
   * Western Digital WD1772: Floppy disk controller.
 
-  * Rockwell R65C52: Serial console and MIDI ports.
-
-  * Motorola MC6840: Timers.
-
-  * Unknown item #1: A program running on a microcontroller. It
-    converts the analog signals from the Buchla's controller pads to
-    digital values.
+  * A few LEDs.
+
+  * Item X: A program running on a microcontroller. It converts the
+    analog signals from the Buchla's controller pads to digital
+    values.
 
     Neither the program, nor the microcontroller are known, but the
@@ -301,21 +321,8 @@
     and self-explanatory.
 
-The next development milestone will hopefully emulate the following
-additional components:
-
-  * National Semiconductor LMC835: Equalizer.
-
-  * General Instrument AY-3-8910: A sound chip, which is not used for
-    sound generation, but only for its I/O ports. It connects the CPU
-    to the above equalizer chip.
-
-  * A few indicator LEDs.
-
-  * Unknown item #2: The actual sound generator, referred to by the
-    firmware source code as "the FPU." This is the biggest unknown so
-    far. Judging from the firmware source code it consist of two
-    parts:
-
-      1. The function generator that generates the 15 different
+  * Item Y: The actual sound generator, referred to by the firmware
+    source code as "the FPU." This could actually be two chips:
+
+      1. One chip, maybe a DSP, for generating the 15 different
          parameter envelopes for each of the 12 voices:
 
@@ -332,11 +339,11 @@
            - 1x Output signal stereo location.
 
-           - 1x "Dynamics" - whatever that is.
-
-         The firmware feeds the the points of the envelopes drawn in
-         the MIDAS VII instrument editor to the function generator,
-         which then interpolates between them.
-
-      2. The digital oscillator.
+           - 1x "Dynamics." (TBD - currently not emulated.)
+
+         Over time, the chip interpolates between the points of the
+         envelopes drawn in the MIDAS VII instrument editor.
+
+      2. A second chip for the actual sound generation. This is likely
+         a DSP.
 
          XXX - Details to be filled in.
@@ -346,16 +353,11 @@
          of the envelopes probably control analog circuits.
 
-    This "two FPU parts" hypothesis would be in line with the "four
+         Obviously, the emulator does everything digitally.
+
+    This "two chip" hypothesis would be in line with the "four
     computers" marketing claim from the Buchla 700 marketing copy. The
     four "computers" would be the Motorola 68000, the microcontroller
-    that does the A/D conversion of the pad inputs, plus the two parts
+    that does the A/D conversion of the pad inputs, plus the two CPUs
     that constitute "the FPU."
-
-    The firmware source code archive indicates that the FPU is based
-    on micro-programmable hardware. We recently ran this by Lynx, the
-    developer of the firmware, who generously agreed to meet up with
-    us in Oakland, CA. While he did not work on the FPU and thus was
-    not familiar with its implementation details, he was able to
-    confirm that the FPU is based on AMD's Am2900 family.
 
 If you have access to an actual Buchla 700, please do contact us. It
@@ -363,4 +365,3 @@
 
 If your Buchla is non-functional, this is also fine. We might be able
-to gain some insights from reading out the FPU microcode PROMs or from
-figuring out how the FPU chips are wired together.
+to gain some insights from reading out the FPU microcode PROMs.